# gofimports

[![Go](https://github.com/haunt98/gofimports/workflows/Go/badge.svg?branch=main)](https://github.com/haunt98/gofimports/actions)
[![Go Reference](https://pkg.go.dev/badge/github.com/haunt98/gofimports.svg)](https://pkg.go.dev/github.com/haunt98/gofimports)

Group Go imports with my opinionated preferences.

First is **standard**.
Then **third party**, then **company** if exist.
The last is **local**.

Also main selling point of this tool is to group imports not sort them.
So please run `gofumpt` or `gofmt` after running this tool.

Under the hood, this tool get all imports, then group them into 4 groups (std, third party, company, local).
Remember, **no** sort here.
Then insert empty import (empty path) between each group to get final imports
Then update Go ast decls import with final imports.

## Install

With Go version `>= 1.16`:

```sh
go install github.com/haunt98/gofimports/cmd/gofimports@latest
```

## Usage

```sh
# Format ./internal
# with print impacted file (-l),
# write to file (-w),
# print diff (-d)
# company is github.com/make-go-great
gofimports -l -company github.com/make-go-great -w -d ./internal
```

Example result:

```go
import (
    "fmt"

    "github.com/urfave/cli/v2"
    "github.com/pkg/diff"

    "github.com/make-go-great/color-go"

    "github.com/haunt98/gofimports/internal/imports"
)
```

## Roadmap

- [ ] Diff with color
- [ ] Add profiling
- [ ] Improve performance

## Thanks

- [goimports](https://pkg.go.dev/golang.org/x/tools/cmd/goimports)
- [mvdan/gofumpt](https://github.com/mvdan/gofumpt)
- [incu6us/goimports-reviser](https://github.com/incu6us/goimports-reviser)
- [dave/dst](https://github.com/dave/dst)
